import React, { PropTypes } from 'react';


export default ({
    block,
    displayName,
    Dropdown
}) => {

    return React.createClass({

        displayName,

        propTypes: {
            disabled: PropTypes.bool,
            expanded: PropTypes.bool,
            onExpand: PropTypes.func,
            options: PropTypes.arrayOf(
                PropTypes.shape({
                    disabled: PropTypes.bool,   // all
                    onClick: PropTypes.func,    // action
                    query: PropTypes.object,    // route
                    text: PropTypes.string,     // all
                    to: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),  // link (string), route
                    type: PropTypes.oneOf(['action', 'link', 'route', 'value']),    // all
                    value: PropTypes.string                                         // value
                })
            )
        },

        getDefaultProps() {
            return {
                disabled: false,
                expanded: false,
                onExpand: () => {},
                options: []
            };
        },

        onClick() {
            if (this.props.disabled) {
                return;
            }

            this.props.onExpand();
        },

        render() {
            const { expanded, options } = this.props;

            if (!expanded) {
                const disabled = this.props.disabled || options.length === 0;
                return (
                    <div
                        className={ block({ enabled: !disabled, disabled }) }
                        onClick={ this.onClick }>
                        <i className={ block('icon') } />
                    </div>
                );
            }

            return (
                <Dropdown { ...this.props } />
            );
        }

    });

};
