import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import { Link } from 'react-router';


export default ({
    block,
    displayName
} = {}) => {

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            disabled: PropTypes.bool,
            highlighted: PropTypes.bool,
            query: PropTypes.object,
            text: PropTypes.string,
            to: PropTypes.string
        },

        getDefaultProps() {
            return {
                disabled: false,
                highlighted: false,
                query: {},
                text: '',
                to: ''
            };
        },

        onClick(evt) {
            if (this.props.disabled) {
                evt.preventDefault();
            }
        },

        render() {
            const { disabled, highlighted, query, text, to } = this.props;
            return (
                <Link
                    className={ block('option', { disabled, highlighted }) }
                    onClick={ this.onClick }
                    title={ text }
                    to={ typeof this.props.to === 'string' ? { pathname: to, query } : to }>
                    { text }
                </Link>
            );
        }

    });

};
