import reduceReducers from 'reduce-reducers';
import Immutable from 'seamless-immutable';

import { reducer as mount } from './components/component/redux-actions/mount';
import { reducer as unmount } from './components/component/redux-actions/unmount';

import { reducer as checkboxChange } from './components/checkbox/redux-actions/checkboxChange';

import { reducer as dropdownChange } from './components/dropdown/redux-actions/dropdownChange';
import { reducer as dropdownCollapse } from './components/dropdown/redux-actions/dropdownCollapse';
import { reducer as dropdownExpand } from './components/dropdown/redux-actions/dropdownExpand';
import { reducer as dropdownHighlightedIndexChange } from './components/dropdown/redux-actions/dropdownHighlightedIndexChange';

import { reducer as textareaChange } from './components/textarea/redux-actions/textareaChange';
import { reducer as textboxChange } from './components/textbox/redux-actions/textboxChange';

import convertActionObjectToHandlers from './utils/convertActionObjectToHandlers';


export default ({
    actionObject = {},
    defaultState = {},
    reducers = []
} = {}) => {
    return (state = Immutable(defaultState), action) => {
        return reduceReducers(
            checkboxChange,

            dropdownChange,
            dropdownCollapse,
            dropdownExpand,
            dropdownHighlightedIndexChange,

            textareaChange,

            textboxChange,

            ...convertActionObjectToHandlers({
                ...mount,
                ...unmount
            }),

            ...convertActionObjectToHandlers(actionObject),
            ...reducers
        )(state, action);
    };
};
